const express = require("express");
const app = express();
// const mysql = require('mysql');
const http = require("http");
const liveLocationController = require("./controller/livelocation");
const userChatController = require("./controller/userChat/chat");
const TrackOrderController = require("./controller/TrackOrder");
const SupportDriverController = require("./controller/SupportDriver");
const serve = http.createServer(app);
const Room = require("../socketServer/models/room");
app.get("/test", (req, res) => {
    res.send("ux`");
});
const { Server } = require("socket.io");
const { result } = require("lodash/object");
const chat = require("./controller/userChat/chat");
const support = require("./controller/userChat/support");
const mysql = require("mysql");
const UserChat = require("./models/userChat");
// const io = new Server(serve);
const io = new Server(serve, {
    maxHttpBufferSize: 1e9,
    pingTimeout: 60000,
});
const RequestSupport = io.of("/socket/SupportRequest");
const New_message = io.of("/socket/New_message");
const TrackOrderspace = io.of("/socket/TrackOrder");
const ChatNamespace = io.of("/socket/Chat");
const handOff = io.of("/socket/handOff");
var config = {
    user: "deliverydigisola_user",
    database: "deliverydigisola_db",
    password: ".v=Fcpv5g)FE",
    host: "localhost", //process.env.DB_HOSTNAME,
};

var connection = mysql.createConnection(config);
connection.connect((error) => {
    if (error) throw error;
    console.log("Successfully connected to the database.");
});

const vendorNs = io.of("/vendor");

vendorNs.on("connection", async (socket) => {
    if (!socket.request.headers.branchid) return;
    await socket.join(`bid ${socket.request.headers.branchid}`);
    socket.emit("test", { data: "this is test data" });
    socket.on("changeStatus", (data) => {
        console.log(data);
        vendorNs
            .to("bid 1")
            .emit("changeStatus", { data: "more specific room data" });
    });
});

app.get("/NewOrder", (req, res) => {
    var orderId = req.query.data;
    sql = "select * from orders  where id =?";
    connection.query(sql, [orderId], function (error, results, fields) {
        //io.emit( 'NewOrder', JSON.stringify(results));

        if (error === null) {
            // res.send(results);
            const selectedBranch = results[0].branch_id;
            vendorNs.emit("NewOrder", JSON.stringify(results));
        } else {
            vendorNs
                .to(`bid ${selectedBranch}`)
                .emit("NewOrder", "error order id not found");
        }
    });

    res.send("success add order  orderId");
});

app.get("/driver", (req, res) => {
    let orderId = req.query.order_id;
    console.log("order_id", orderId);
    res.send("success");
    driverNs.emit("handOff", { order_id: parseInt(orderId) });
});

app.get("/SupportRequest", async (req, res) => {
    const id = req.query.id;
    const room_id = req.query.room_id;
    const last_message = req.query.last_message;
    const user_name = req.query.user_name;
    const created_at = req.query.created_at;
    console.log([id, room_id, user_name, last_message]);
    res.send("success");
    RequestSupport.emit("gitSupport", {
        id: parseInt(id),
        room_id: room_id,
        last_message: last_message,
        user_name: user_name,
        created_at: created_at,
    });
    RequestSupport.emit("newMessage", { new: "new_message" });
});

const driverNs = io.of("/driver");

driverNs.on("connection", async (socket) => {
    let driver_id = socket.handshake.headers["id"];
    await socket.join(`driver_id` + driver_id);
    liveLocationController.add(socket);
    TrackOrderController.track(socket, driverNs);
    SupportDriverController.support(socket, driverNs);
    console.log(`driver_id` + driver_id);
    console.log("driver connection on " + driver_id);
    socket.on("test", function () {
        socket.emit("test", "tt");
    });
});

app.get("/AcceptOrder", (req, res) => {
    var orderId = req.query.data;
    var type = req.query.type;
    var driver = req.query.driver;
    var distance_pick_up = parseFloat(req.query.pick_up);
    var distance_drop_off = parseFloat(req.query.drop_off);
    var type_number = parseInt(req.query.type_number);
    if (type == "normal") {
        sql =
            "SELECT orders.id,orders.order_number,orders.phone_number as Customer_phone,lang_translations.translate_title as Store_name,stores.phone_number as Store_phone FROM `orders` join stores on orders.store_id = stores.id join lang_translations on stores.lang_id=lang_translations.id where orders.id = ?";
    } else {
        sql =
            "SELECT id,order_number,phone_number as Customer_phone FROM `order_shipments` WHERE id = ?";
    }

    setTimeout(() => {
        try {
            connection.query(sql, [orderId], function (error, results, fields) {
                if (error) {
                    console.error("Error executing SQL query:", error);
                    driverNs
                        .to("driver_id" + driver)
                        .emit("AcceptOrder", "error order id not found");
                    console.log(
                        "=======================3========================"
                    );
                    return;
                }

                if (type == "normal") {
                    results[0].type = type;
                    results[0].type_number = type_number;
                    results[0].distance_pick_up = distance_pick_up;
                    results[0].distance_drop_off = distance_drop_off;
                    console.log(results[0]);
                    driverNs
                        .to("driver_id" + driver)
                        .emit("AcceptOrder", JSON.stringify(results));
                    console.log(
                        `=======================${driver}========================`
                    );
                } else {
                    var checkSql =
                        "SELECT * FROM `order_shipments` WHERE `parent_order` = ?";
                    connection.query(
                        checkSql,
                        [orderId],
                        function (checkError, checkResults, checkFields) {
                            if (checkError) {
                                console.error(
                                    "Error executing child check query:",
                                    checkError
                                );
                                driverNs
                                    .to("driver_id" + driver)
                                    .emit(
                                        "AcceptOrder",
                                        "error checking for children"
                                    );
                                console.log(
                                    "=======================3========================"
                                );
                                return;
                            }

                            var children = checkResults.length > 0;

                            if (children) {
                                results[0].order_number +=
                                    " - #" + checkResults[0].order_number;
                                results[0].type = type;
                                results[0].type_number = type_number;
                                results[0].distance_pick_up = distance_pick_up;
                                results[0].distance_drop_off =
                                    distance_drop_off;
                                results[0].children = children;
                                console.log(results[0]);
                                driverNs
                                    .to("driver_id" + driver)
                                    .emit(
                                        "AcceptOrder",
                                        JSON.stringify(results)
                                    );
                                console.log(
                                    `=======================${driver}========================`
                                );
                            } else {
                                results[0].type = type;
                                results[0].type_number = type_number;
                                results[0].distance_pick_up = distance_pick_up;
                                results[0].distance_drop_off =
                                    distance_drop_off;
                                results[0].children = children;
                                console.log(results[0]);
                                driverNs
                                    .to("driver_id" + driver)
                                    .emit(
                                        "AcceptOrder",
                                        JSON.stringify(results)
                                    );
                                console.log(
                                    `=======================${driver}========================`
                                );
                            }
                        }
                    );
                }
            });
        } catch (err) {
            console.error("Error executing SQL query:", err);
        }
    }, 900);

    res.send("success Accept Order  orderId");
});

ChatNamespace.on("connect", async (socket) => {
    socket.on("sendheader", (data) => {
        //
        console.log(
            "******************************************************************************",
            "asa"
        );
        console.log("1");
        let user_id = data.user_id;
        // let user_id = 228;
        console.log("new user connect user_id" + user_id);

        let room_id = data.room_id;
        // let room_id = "HgrR1p9sVI5LwsPv9FFDtuYNfo4p0V";
        socket.join(room_id);
        console.log("new user  connect on room_id" + room_id);

        // await socket.join(`driver_id` + driver_id);
        chat.send(socket, user_id, room_id, RequestSupport);
    });
});

RequestSupport.on("connect", async (socket) => {
    // console.log("supportId ++++++++++++++"+supportId);
    // console.log("roomId+++++++++++++++++"+roomId);
    // await socket.join(`driver_id` + driver_id);
    support.send(socket);
});

TrackOrderspace.on("connect", async (socket) => {
    console.log(
        "******************************************************************************",
        "asa"
    );
    let user_id = socket.handshake.headers["id"];
    socket.join(`driver_id${user_id}`);
    console.log(`driver_id${user_id}`);
    socket.on("track-order", async (data) => {
        console.log(data);
        TrackOrderspace.to(`driver_id${user_id}`).emit("TrackOrder", data);
    });

    console.log("ssss");
    console.log(user_id);
    socket.join(socket.request.driver_id);
    let userid = socket.request.driver_id;
    console.log(userid);
    console.log(
        "******************************************************************************",
        user_id
    );
    console.log(
        "******************************************************************************",
        user_id
    );
    userChatController.send(socket);
    await helper.getUserImage(socket.request.user.id);
});

app.get("/changeOrderStatus", (req, res) => {
    const orders = req.query.orders;
    const newStatus = req.query.newStatus;
    const selectedBranch = req.query.branch;

    switch (newStatus) {
        case 1:
            vendorNs
                .to(`bid ${selectedBranch}`)
                .emit("AddNewOrder", JSON.stringify(orders[0]));
            break;
        case 4:
            vendorNs
                .to(`bid ${selectedBranch}`)
                .emit("RemovePreparedOrders", JSON.stringify(orders));
            vendorNs
                .to(`bid ${selectedBranch}`)
                .emit("AddReadyOrders", JSON.stringify(orders));
            break;
        case 5:
            vendorNs
                .to(`bid ${selectedBranch}`)
                .emit("RemoveReadyOrder", JSON.stringify(orders[0]));
            vendorNs
                .to(`bid ${selectedBranch}`)
                .emit("AddDeliveredOrder", JSON.stringify(orders[0]));
            break;
        case 6:
        default:
            vendorNs
                .to(`bid ${selectedBranch}`)
                .emit("AddCancelledOrder", JSON.stringify(orders[0]));
            break;
    }
});

serve.listen(4660, () => {
    console.log("listening on *:4660 ");
});
