const {Model, DataTypes, sequelize} = require('../utiles/database')

class User extends Model {}

User.init({
    id: {
        type: DataTypes.BIGINT,
        allowNull: false,
        unsigned: true,
        autoIncrement: true,
        primaryKey: true
    },
    name: {
        type: DataTypes.STRING,
        allowNull: false,
    },

    email: {
        type: DataTypes.STRING,
        unique:true,
        allowNull: false,
    },

    status: {
        type: DataTypes.BOOLEAN,
        defaultValue:true,
    },


    Type: {
        type: DataTypes.CHAR,
        defaultValue:"u",
    },
    device_token: {
        type: DataTypes.STRING,
        defaultValue:"u",
    },
}, {sequelize, createdAt: "created_at", updatedAt: "updated_at", tableName:"users"});

module.exports = User;
