const {Model, DataTypes, sequelize} = require('../utiles/database')

class UserLocation extends Model {}

UserLocation.init({
    id: {
        type: DataTypes.BIGINT,
        allowNull: false,
        unsigned: true,
        autoIncrement: true,
        primaryKey: true
    },
    title: {
        type: DataTypes.STRING,
        allowNull: false,
    },
    lat: {
        type: DataTypes.DECIMAL,
        allowNull: false,
    },
    lng: {
        type: DataTypes.DECIMAL,
        allowNull: false,
    },
    region: {
        type: DataTypes.STRING,
        allowNull: false,
    },
    apartment_number: {
        type: DataTypes.STRING,
        allowNull: false,
    },
    building_name: {
        type: DataTypes.STRING,
        allowNull: false,
    },
    street: {
        type: DataTypes.STRING,
        allowNull: false,
    },
    description: {
        type: DataTypes.STRING,
        allowNull: false,
    },
    user_id: {
        type: DataTypes.BIGINT,
        allowNull: false,
        unsigned: true,
    },
    
}, {sequelize, createdAt: "created_at", updatedAt: "updated_at", tableName:"users_locations"});

module.exports = UserLocation