const {Model, DataTypes, sequelize} = require('../utiles/database')

class UserLiveLocation extends Model {}

UserLiveLocation.init({
    id: {
        type: DataTypes.BIGINT,
        allowNull: false,
        unsigned: true,
        autoIncrement: true,
        primaryKey: true
    },
    
    lat: {
        type: DataTypes.DECIMAL,
        allowNull: false,
    },
    lng: {
        type: DataTypes.DECIMAL,
        unique:true,
        allowNull: false,
    },
    available: {
        type: DataTypes.BOOLEAN,
        allowNull: false,
        defaultValue: false
    },
    user_id: {
        type: DataTypes.BIGINT,
        allowNull: false,
        unsigned: true,
    },
    
}, {sequelize, createdAt: "created_at", updatedAt: "updated_at", tableName:"users_live_location"});

module.exports = UserLiveLocation